STRUCT  Stars
EXTNAME STARS
TYPE    BINTABLE
SIZE    248

FIELD     X,                X,          double,    x coordinate on image,	     pixels
FIELD     Y,                Y,          double,    y coordinate on image,	     pixels
FIELD     dX,               dX,         double,    x coordinate error,	             pixels
FIELD     dY,               dY,         double,    y coordinate error,  	     pixels
FIELD     R,                R,          double,    ra coordinate on sky,	     decimal degrees
FIELD     D,                D,          double,    dec coordinate on sky,	     decimal degrees
FIELD     dR,               dR,         double,    ra error,			     arcsec
FIELD     dD,               dD,         double,    dec error,			     arcsec
FIELD     uR,               U_RA,       double,    proper motion in RA,		     milliarcsec/year
FIELD     uD,               U_DEC,      double,    proper motion in DEC,	     milliarcsec/year
FIELD     duR,              U_RA_ERR,   double,    p-m error in RA,		     milliarcsec/year
FIELD     duD,              U_DEC_ERR,  double,    p-m error in DEC,		     milliarcsec/year
FIELD     P,                PAR,        double,    parallax,			     milliarcsec
FIELD     dP,               PAR_ERR,    double,    parallax error,		     milliarcsec
FIELD     M,                M,          double,    instrumental mag
FIELD     dM,               DM,         double,    error on mag
FIELD     dMcal,            DMCAL,      double,    systematic error on mag
FIELD     sky,              SKY,        double,    local sky counts
FIELD     dsky,             dSKY,       double,    local sky error counts
FIELD     fx,               FX,         double,    object FWHM x-dir,		     pixels?
FIELD     fy,               FY,         double,    object FWHM y-dir,		     pixels?
FIELD     df,               DF,         double,    object position angle,	     degrees
# FIELD     Mgal,             MGAL,       double,    alternative (galaxy) magnitude
FIELD     Map,              MAP,        double,    alternative (aperture) magnitude
FIELD     Mpeak,            MPEAK,      double,    alternative (peak) magnitude
FIELD     detID,            ID,         int,       detection identifier
FIELD     imageID,          IMAGE_ID,   int,       image identifier
FIELD     found,            FOUND,      int,       found in database catalog?
FIELD     t,                T,          e_time,    date/time of exposure (UNIX)
FIELD     dt,               EXPTIME,    float,     exposure time,                    2.5*log(exptime)
FIELD     psfChisq,         PSF_CHISQ,  float
FIELD     crNsigma,         CR_NSIGMA,  float
FIELD     extNsigma,        EXT_NSIGMA, float
FIELD     psfQual,          PSF_QUAL,   float
FIELD     Mcal,             MCAL,       float,     image cal mag,	             mag
FIELD     airmass,          AIRMASS,    float,     (airmass - 1),		     airmass
FIELD     az,     	    AZ,         float,     azimuth
FIELD     code,             CODE,       short
FIELD     nFrames,          N_FRAMES,   short
FIELD     flags,            FLAGS,      short
FIELD     dophot,           DOPHOT,     char,      dophot type code
FIELD     dummy,            DUMMY,      char

# XXX I'm going to need azimuth (or load from image header?)

# double:   24 * 8 : 192
# int/float:10 * 4 :  40
# short:     2 * 2 :   4
# char:      4 * 1 :   4

# this structure is only used internally and for interprocess communication (addstar)
# dR, uR, etc should be better defined at the pole...
# define down the types to floats where reasonable (all but R,D)?
# R,D should be in ICRS, J2000, epoch 2000 : precess as needed, apply p-m as needed
