STRUCT  Image_Loneos
EXTNAME DVO_IMAGE_LONEOS
TYPE 	BINTABLE
SIZE 	240

# elements of the image structure

SUBSTRUCT coords,           COORDS,               Coords,        astrometric data
SUBFIELD  crval1,           CRVAL1,               double,   	 coordinate at reference pixel
SUBFIELD  crval2,           CRVAL2,               double,  	 coordinate at reference pixel
SUBFIELD  crpix1,           CRPIX1,               float,   	 coordinate of reference pixel
SUBFIELD  crpix2,           CRPIX2,               float,   	 coordinate of reference pixel
SUBFIELD  cdelt1,           CDELT1,               float,   	 degrees per pixel
SUBFIELD  cdelt2,           CDELT2,               float,    	 degrees per pixel
SUBFIELD  pc1_1,            PC1_1,                float,    	 rotation matrix
SUBFIELD  pc1_2,            PC1_2,                float,    	 rotation matrix
SUBFIELD  pc2_1,            PC2_1,                float,    	 rotation matrix
SUBFIELD  pc2_2,            PC2_2,                float,    	 rotation matrix
SUBFIELD  polyterms,        POLYTERMS,            float[7][2],	 higher order warping terms
SUBFIELD  ctype,            CTYPE,                char[15],      coordinate type
SUBFIELD  Npolyterms,       NPOLYTERMS,           char,     	 order of polynomial

FIELD 	  tzero,            TZERO,                e_time,         readout time (row 0)
FIELD 	  nstar,            NSTAR,                unsigned int,   number of stars on image
FIELD 	  secz,             SECZ,                 short,      	  airmass,                   milliairmass
FIELD 	  NX,               NX,                   short,      	  image width
FIELD 	  NY,               NY,                   short,      	  image height
FIELD 	  apmifit,          APMIFIT,              short,      	  aperture correction,       millimag
FIELD 	  dapmifit,         DAPMIFIT,             short,      	  apmifit error,             millimag
FIELD 	  source,           SOURCE,               short,      	  identifier for CCD,
FIELD 	  Mcal,             MCAL,                 short,      	  calibration mag,           millimag
FIELD 	  dMcal,            DMCAL,                short,      	  error on Mcal,             millimag
FIELD 	  Xm,               XM,                   short,      	  image chisq,               10*log(value)
FIELD 	  name,             NAME,                 char[32],       name of original image 
FIELD 	  detection_limit,  DETECTION_LIMIT,      unsigned char,  detection limit,           10*mag
FIELD 	  saturation_limit, SATURATION_LIMIT,     unsigned char,  saturation limit,          10*mag
FIELD 	  cerror,           CERROR,               unsigned char,  astrometric error,         50*arcsec
FIELD 	  fwhm_x,           FWHM_X,               unsigned char,  PSF x width,               25*arcsec
FIELD 	  fwhm_y,           FWHM_Y,               unsigned char,  PSF y width,               25*arcsec
FIELD 	  trate,            TRATE,                unsigned char,  scan rate,                 100 usec/pixel
FIELD 	  exptime,          EXPTIME,              float,          exposure time,             seconds
FIELD 	  code,             CODE,                 char,           image quality flag
FIELD 	  ccdnum,           CCDNUM,               unsigned char,  CCD ID number
FIELD 	  dummy,            DUMMY,                char[20],       unused
FIELD 	  order,            ORDER,                short,      	  Mrel 2D polynomical order 
FIELD 	  Mx,               MX,                   short,      	  Mrel polyterm
FIELD 	  My,               MY,                   short,      	  Mrel polyterm
FIELD 	  Mxx,              MXX,                  short,      	  Mrel polyterm
FIELD 	  Mxy,              MXY,                  short,      	  Mrel polyterm
FIELD 	  Myy,              MYY,                  short,      	  Mrel polyterm
FIELD 	  Mxxx,             MXXX,                 short,      	  Mrel polyterm
FIELD 	  Mxxy,             MXXY,                 short,      	  Mrel polyterm
FIELD 	  Mxyy,             MXYY,                 short,      	  Mrel polyterm
FIELD 	  Myyy,             MYYY,                 short,      	  Mrel polyterm
FIELD 	  Mxxxx,            MXXXX,                short,      	  Mrel polyterm
FIELD 	  Mxxxy,            MXXXY,                short,      	  Mrel polyterm
FIELD 	  Mxxyy,            MXXYY,                short,      	  Mrel polyterm
FIELD 	  Mxyyy,            MXYYY,                short,      	  Mrel polyterm
FIELD 	  Myyyy,            MYYYY,                short,      	  Mrel polyterm
