STRUCT       Image_Panstarrs_DEV_1
EXTNAME      DVO_IMAGE_PANSTARRS_DEV_1
TYPE         BINTABLE
SIZE         288
DESCRIPTION  DVO Image Table 

# elements of the image structure

SUBSTRUCT coords,           COORDS,               Coords,        astrometric data
SUBFIELD  crval1,           CRVAL1,               double,   	 coordinate at reference pixel
SUBFIELD  crval2,           CRVAL2,               double,  	 coordinate at reference pixel
SUBFIELD  crpix1,           CRPIX1,               float,   	 coordinate of reference pixel
SUBFIELD  crpix2,           CRPIX2,               float,   	 coordinate of reference pixel
SUBFIELD  cdelt1,           CDELT1,               float,   	 degrees per pixel
SUBFIELD  cdelt2,           CDELT2,               float,    	 degrees per pixel
SUBFIELD  pc1_1,            PC1_1,                float,    	 rotation matrix
SUBFIELD  pc1_2,            PC1_2,                float,    	 rotation matrix
SUBFIELD  pc2_1,            PC2_1,                float,    	 rotation matrix
SUBFIELD  pc2_2,            PC2_2,                float,    	 rotation matrix
SUBFIELD  polyterms,        POLYTERMS,            float[7][2],	 higher order warping terms
SUBFIELD  ctype,            CTYPE,                char[15],      coordinate type
SUBFIELD  Npolyterms,       NPOLYTERMS,           char,     	 order of polynomial
# 120 bytes

FIELD 	  tzero,            TZERO,                e_time,         readout time (row 0)
FIELD 	  nstar,            NSTAR,                unsigned int,   number of stars on image
FIELD 	  secz,             SECZ,                 float,      	  airmass,                   mag
FIELD 	  NX,               NX,                   short,      	  image width
FIELD 	  NY,               NY,                   short,      	  image height
FIELD 	  apmifit,          APMIFIT,              float,      	  aperture correction,       mag
FIELD 	  dapmifit,         DAPMIFIT,             float,      	  apmifit error,             mag
FIELD 	  Mcal,             MCAL,                 float,      	  calibration mag,           mag
FIELD 	  dMcal,            DMCAL,                float,      	  error on Mcal,             mag
FIELD 	  Xm,               XM,                   short,      	  image chisq,               10*log(value)
FIELD 	  photcode,         PHOTCODE,             short,      	  identifier for CCD,
FIELD 	  exptime,          EXPTIME,              float,          exposure time,             seconds
FIELD     sidtime,          ST,			  float,          sidereal time of exposure
FIELD     latitude,         LAT,		  float,          observatory latitude,      degrees
# 40 bytes

FIELD 	  name,             NAME,                 char[64],       name of original image 
FIELD 	  detection_limit,  DETECTION_LIMIT,      unsigned char,  detection limit,           10*mag
FIELD 	  saturation_limit, SATURATION_LIMIT,     unsigned char,  saturation limit,          10*mag
FIELD 	  cerror,           CERROR,               unsigned char,  astrometric error,         50*arcsec
FIELD 	  fwhm_x,           FWHM_X,               unsigned char,  PSF x width,               25*arcsec
FIELD 	  fwhm_y,           FWHM_Y,               unsigned char,  PSF y width,               25*arcsec
FIELD 	  trate,            TRATE,                unsigned char,  scan rate,                 100 usec/pixel
FIELD 	  code,             CODE,                 char,           image quality flag
FIELD 	  ccdnum,           CCDNUM,               unsigned char,  CCD ID number
FIELD 	  imageID_hi,       IMAGE_ID_HI,          unsigned int,   ID upper bytes
FIELD 	  imageID_lo,       IMAGE_ID_LO,          unsigned int,   ID lower bytes
# 48 bytes 

FIELD 	  dummy,            DUMMY,                char[10],       unused
FIELD 	  order,            ORDER,                short,      	  Mrel 2D polynomical order 
FIELD 	  Mx,               MX,                   short,      	  Mrel polyterm
FIELD 	  My,               MY,                   short,      	  Mrel polyterm
FIELD 	  Mxx,              MXX,                  short,      	  Mrel polyterm
FIELD 	  Mxy,              MXY,                  short,      	  Mrel polyterm
FIELD 	  Myy,              MYY,                  short,      	  Mrel polyterm
FIELD 	  Mxxx,             MXXX,                 short,      	  Mrel polyterm
FIELD 	  Mxxy,             MXXY,                 short,      	  Mrel polyterm
FIELD 	  Mxyy,             MXYY,                 short,      	  Mrel polyterm
FIELD 	  Myyy,             MYYY,                 short,      	  Mrel polyterm
FIELD 	  Mxxxx,            MXXXX,                short,      	  Mrel polyterm
FIELD 	  Mxxxy,            MXXXY,                short,      	  Mrel polyterm
FIELD 	  Mxxyy,            MXXYY,                short,      	  Mrel polyterm
FIELD 	  Mxyyy,            MXYYY,                short,      	  Mrel polyterm
FIELD 	  Myyyy,            MYYYY,                short,      	  Mrel polyterm
# 40 bytes
