TABLE camRun, camProcessedExp, chipRun, rawExp, chipProcessedImfile
TITLE Camera Processed Imfiles
FILE  camProcessedImfile.php
MENU  ipp.science.dat

# the following WHERE clauses are added to all queries joined by AND
WHERE camRun.state = 'full'
WHERE camRun.chip_id = chipRun.chip_id
WHERE chipRun.exp_id = rawExp.exp_id
WHERE camProcessedExp.cam_id = camRun.cam_id
WHERE chipProcessedImfile.chip_id = camRun.chip_id

ARGS  ARG1  rawImfile.exp_id=$rawExp.exp_id
ARGS  ARG2  chipRun.chip_id=$chipRun.chip_id
ARGS  ARG3  camRun.cam_id=$camRun.cam_id

OP   OP1  $rawExp.ra * 57.295783
OP   OP2  $rawExp.decl * 57.295783

#     field                     	size  format  name          show   	 link to                  extras
FIELD rawExp.exp_name,     		10,   %s,     Exp Name,     value
FIELD chipProcessedImfile.class_id,  	 8,   %s,     Class ID
FIELD rawExp.exp_id,	        	 5,   %s,     Exp ID,       value,       rawImfile.php,           ARG1
FIELD chipRun.chip_id,          	 5,   %s,     Chip ID,      value,       chipProcessedImfile.php, ARG2
FIELD camRun.cam_id,            	 5,   %s,     Cam ID,       value,       camProcessedExp.php,     ARG3
FIELD camRun.label,             	 5,   %s,     Label
FIELD rawExp.telescope,      		10,   %s,     Telescope
FIELD rawExp.camera,         		10,   %s,     Camera
FIELD rawExp.dateobs,        		19,   %T,     Date/Time
FIELD rawExp.ra,           		 8,   %10.6f, RA,           op=OP1      
FIELD rawExp.decl,         		 8,   %10.6f, DEC,          op=OP2
FIELD rawExp.object,         		10,   %s,     Object
FIELD rawExp.filter,         		10,   %s,     FILTER
FIELD rawExp.exp_time,       		 5,   %.2f,     exp_time    
FIELD rawExp.airmass,        		 5,   %.4f,     airmass     
FIELD chipProcessedImfile.bg,            5,   %.2f,   backgnd
FIELD chipProcessedImfile.bg_stdev,      5,   %.2f,   stdev    
FIELD chipProcessedImfile.bg_mean_stdev, 5,   %.2f,   &lt;backgnd&gt;
FIELD chipProcessedImfile.n_stars,  	 5,   %d,     Nstars
FIELD camProcessedExp.n_astrom, 	 5,   %d,     Nastrom
FIELD camProcessedExp.sigma_ra, 	 5,   %.2f,   sigma ra
FIELD chipProcessedImfile.fwhm_major,  	 5,   %.2f,   FHWM (major)
FIELD rawExp.comment,  	                65,   %s,     Comment

TAIL PHP insert_image ('PPIMAGE.JPEG1');
TAIL PHP insert_log ('LOG.EXP');
