TABLE chipRun, rawExp, chipProcessedImfile
TITLE chip Processed Imfile
FILE  chipProcessedImfile.php
MENU  ipp.science.dat

# limit this table to non-OBJECT types of images
WHERE chipRun.exp_id = rawExp.exp_id
WHERE chipProcessedImfile.exp_id = chipRun.exp_id
WHERE chipProcessedImfile.chip_id = chipRun.chip_id
WHERE chipProcessedImfile.fault = 0

ARGS  ARG1 rawImfile.exp_id=$rawExp.exp_id

ARGS  ARG2 chipRun.chip_id=$chipRun.chip_id

ARGS  ARG3 chipRun.chip_id=$chipRun.chip_id
ARGS  ARG3 chipProcessedImfile.class_id=$chipProcessedImfile.class_id
ARGS  ARG3 camera=$rawExp.camera
ARGS  ARG3 basename=$chipProcessedImfile.path_base
ARGS  ARG3 class=$chipProcessedImfile.class_id

OP   OP1  $rawExp.ra * 57.295783
OP   OP2  $rawExp.decl * 57.295783

#     field                            size  format  name         show    link to                  extras
FIELD rawExp.exp_name,     	   	 10, %s,     Exp Name
FIELD chipProcessedImfile.class_id,  	  8, %s,     Class ID
FIELD rawExp.exp_id,         	   	  5, %d,     Exp ID,      value,  rawImfile.php,           ARG1
FIELD chipRun.chip_id,        	   	  7, %d,     Chip ID,     value,  chipProcessedImfile.php, ARG2
FIELD chipRun.state,        	   	  7, %s,     State,       value,  chipProcessedImfile.php, ARG3
FIELD chipRun.label,        	   	  7, %s,     Label
FIELD rawExp.telescope,      	   	 10, %s,     Telescope
FIELD rawExp.camera,         	   	 10, %s,     Camera
FIELD rawExp.dateobs,        	   	 19, %T,     Date/Time
FIELD rawExp.ra,           	 	  8, %10.6f, RA,           op=OP1      
FIELD rawExp.decl,         	 	  8, %10.6f, DEC,          op=OP2
FIELD rawExp.object,       	   	  8, %s,     Object
FIELD rawExp.filter,         	   	 10, %s,     FILTER
FIELD rawExp.exp_time,       	   	  5, %.2f,   exp_time    
FIELD rawExp.airmass,        	   	  5, %.4f,   airmass     
FIELD chipProcessedImfile.bg,             5, %.2f,   backgnd
FIELD chipProcessedImfile.bg_stdev,       5, %.2f,   stdev    
FIELD chipProcessedImfile.n_stars,  	  5, %d,     Nstars
FIELD chipProcessedImfile.fwhm_major, 	  5, %.2f,   FHWM
FIELD chipProcessedImfile.path_base,      5, %s,     path_base, none
FIELD rawExp.comment,  	                 65, %s,     Comment

TAIL PHP insert_log ('LOG.IMFILE');
