TABLE rawExp
TITLE Raw Science Exposures
FILE  rawScienceExp.php
MENU  ipp.load.dat

# limit this table to OBJECT types of images
WHERE (rawExp.exp_type = 'OBJECT' or rawExp.exp_type = 'LIGHT')

ARGS ARG1 rawImfile.exp_id=$exp_id

OP   OP1  $ra * 57.295783
OP   OP2  $decl * 57.295783

#        field        size format  name           show          link to   extras
FIELD    exp_id,       5,  %d,     Exp ID
FIELD    exp_name,     8,  %s,     Exp Name,     value,   rawImfile.php,  ARG1
FIELD    telescope,    8,  %s,     Telescope
FIELD    camera,       8,  %s,     Camera
FIELD    dateobs,     19,  %T,     Date/Time
FIELD    ra,           8,  %10.6f, RA,           op=OP1      
FIELD    decl,         8,  %10.6f, DEC,          op=OP2
FIELD    object,       8,  %s,     object
FIELD    filter,      10,  %s,     FILTER
FIELD    exp_time,     5,  %s,     exp_time    
FIELD    airmass,      5,  %.4f,   airmass     
FIELD    exp_time,     5,  %.2f,   exp_time    
FIELD    ccd_temp,     5,  %.2f,   ccd_temp
FIELD    pon_time,     5,  %.2f,   pon_time
FIELD    sat_pixel_frac, 5,   %.4f,   f(sat pixels)
FIELD    bg,	       8,  %.2f,   backgnd
FIELD    bg_stdev,     8,  %.2f,   stdev
FIELD    bg_mean_stdev, 8, %.2f,   [stdev]
FIELD    comment,      80,  %s,     Comment
