TABLE stackInputSkyfile, stackRun, warpRun, warpSkyfile, fakeRun, camRun, camProcessedExp, chipRun, rawExp
TITLE Stack Input Exposures
FILE  stackInputSkyfile.php
MENU  ipp.stack.dat

WHERE stackRun.stack_id = stackInputSkyfile.stack_id
WHERE stackInputSkyfile.warp_id = warpRun.warp_id
WHERE warpRun.fake_id = fakeRun.fake_id
WHERE warpSkyfile.warp_id = warpRun.warp_id
WHERE warpSkyfile.skycell_id = stackRun.skycell_id
WHERE fakeRun.cam_id = camRun.cam_id
WHERE camProcessedExp.cam_id = camRun.cam_id
WHERE camRun.chip_id = chipRun.chip_id
WHERE chipRun.exp_id = rawExp.exp_id

ARGS  ARG1  rawImfile.exp_id=$rawExp.exp_id
ARGS  ARG2  chipRun.chip_id=$chipRun.chip_id
ARGS  ARG3  camRun.cam_id=$camRun.cam_id
ARGS  ARG4  fakeRun.fake_id=$fakeRun.fake_id
ARGS  ARG5  warpRun.warp_id=$warpRun.warp_id

OP   OP1  $rawExp.ra * 57.295783
OP   OP2  $rawExp.decl * 57.295783

#        field                          size  format  name           show     link to         extras
FIELD rawExp.exp_name,     	    5, %s,     Exp Name
FIELD rawExp.exp_id,     	    5, %d,     Exp ID,       value,  rawImfile.php,           ARG1
FIELD chipRun.chip_id,    	    7, %d,     Chip ID,      value,  chipProcessedImfile.php, ARG2
FIELD camRun.cam_id,    	    7, %d,     Cam ID,       value,  camProcessedExp.php,     ARG3
FIELD fakeRun.fake_id,    	    7, %d,     Fake ID,      value,  fakeProcessedImfile.php, ARG4
FIELD warpRun.warp_id,    	    7, %d,     Warp ID,      value,  warpStageExp.php,        ARG5
FIELD stackInputSkyfile.stack_id,   5, %s,     Stack ID
FIELD stackRun.skycell_id,          5, %s,     Skycell ID
FIELD stackRun.state,    	    7, %s,     State
FIELD rawExp.telescope,      	   10, %s,     Telescope
FIELD rawExp.camera,         	   10, %s,     Camera
FIELD rawExp.dateobs,        	   19, %T,     Date/Time
FIELD rawExp.ra,       	            8, %10.6f, RA,          op=OP1    
FIELD rawExp.decl,       	    8, %10.6f, DEC,         op=OP2
FIELD rawExp.object,         	    8, %s,     Object
FIELD rawExp.filter,         	   10, %s,     Filter
FIELD rawExp.exp_time,       	    5, %.2f,   exp_time    
FIELD rawExp.airmass,        	    5, %.4f,   airmass     
FIELD camProcessedExp.fwhm_major,   5, %.4f,   FWHM     
FIELD warpSkyfile.good_frac,   	    7, %.4f,   warp good f
FIELD rawExp.bg,             	    5, %.2f,   backgnd
FIELD rawExp.bg_stdev,       	    5, %.2f,   stdev    
FIELD rawExp.comment,  	           65, %s,     Comment

