TABLE warpSkyCellMap, warpRun, fakeRun, camRun, chipRun, rawExp, chipProcessedImfile
TITLE Warp Stage Skyfile Inputs
FILE  warpStageSkyfileInputs.php
MENU  ipp.science.dat

WHERE warpSkyCellMap.warp_id = warpRun.warp_id
WHERE warpRun.fake_id = fakeRun.fake_id
WHERE fakeRun.cam_id = camRun.cam_id
WHERE camRun.chip_id = chipRun.chip_id
WHERE chipRun.exp_id = rawExp.exp_id
WHERE chipProcessedImfile.chip_id = chipRun.chip_id
WHERE chipProcessedImfile.class_id = warpSkyCellMap.class_id

ARGS  ARG1  rawImfile.exp_id=$rawExp.exp_id
ARGS  ARG2  chipRun.chip_id=$chipRun.chip_id
ARGS  ARG3  camRun.cam_id=$camRun.cam_id
ARGS  ARG4  fakeRun.fake_id=$fakeRun.fake_id
ARGS  ARG5  warpRun.warp_id=$warpRun.warp_id

ARGS  ARG6  chipRun.chip_id=$chipRun.chip_id
ARGS  ARG6  chipProcessedImfile.class_id=$warpSkyCellMap.class_id
ARGS  ARG6  camera=$rawExp.camera
ARGS  ARG6  basename=$chipProcessedImfile.path_base
ARGS  ARG6  class=$warpSkyCellMap.class_id

OP   OP1  $rawExp.ra * 57.295783
OP   OP2  $rawExp.decl * 57.295783

#     field                    size  format  name         show    link to         extras
FIELD rawExp.exp_name,     	 10, %s,     Exp Name
FIELD warpSkyCellMap.class_id,    8, %s,     Class ID,     value,  chipProcessedImfile.php, ARG6
FIELD rawExp.exp_id,     	  5, %d,     Exp ID,       value,  rawImfile.php,           ARG1
FIELD chipRun.chip_id,    	  7, %d,     Chip ID,      value,  chipProcessedImfile.php, ARG2
FIELD camRun.cam_id,    	  7, %d,     Cam ID,       value,  camProcessedExp.php,     ARG3
FIELD fakeRun.fake_id,    	  7, %d,     Fake ID,      value,  fakeProcessedImfile.php, ARG4
FIELD warpRun.warp_id,    	  7, %d,     Warp ID,      value,  warpStageExp.php, ARG5
FIELD warpRun.state,    	  7, %s,     state
FIELD warpRun.label,    	  7, %s,     label
FIELD warpSkyCellMap.skycell_id, 10, %s,     skycell
FIELD warpSkyCellMap.tess_id,    10, %s,     tess
FIELD warpSkyCellMap.fault,      10, %s,     fault
FIELD rawExp.telescope,      	 10, %s,     Telescope
FIELD rawExp.camera,         	 10, %s,     Camera
FIELD rawExp.dateobs,        	 19, %T,     Date/Time
FIELD rawExp.ra,       	          8, %10.6f, RA,          op=OP1    
FIELD rawExp.decl,       	  8, %10.6f, DEC,         op=OP2
FIELD rawExp.object,         	  8, %s,     Object
FIELD rawExp.filter,         	 10, %s,     FILTER
FIELD rawExp.exp_time,       	  5, %.2f,   exp_time    
FIELD rawExp.airmass,        	  5, %.4f,   airmass     
FIELD rawExp.bg,             	  5, %.2f,   backgnd
FIELD rawExp.bg_stdev,       	  5, %.2f,   stdev    
FIELD rawExp.comment,  	         65, %s,     Comment

FIELD chipProcessedImfile.path_base, 65, %s, path_base, none

# FIELD rawExp.bg_mean_stdev,  	 5, %7.2f,  &lt;backgnd&gt;
# FIELD chipPendingExp.reduction,    20,   reduction
# FIELD chipPendingExp.guide_id,     20, guide ID
