use Module::Build;
# See perldoc Module::Build for details of how this works

Module::Build->new(
    module_name         => 'ippscripts',
    dist_version        => '0.01',
    author              => 'Joshua Hoblitt <jhoblitt@cpan.org>',
    license             => 'gpl',
    create_makefile_pl  => 'passthrough',
    requires            => {
        'Astro::FITS::CFITSIO'      => 0,
        'Cache::File'               => 0,
        'Carp'                      => 0,
        'Data::Dumper'              => 0,
        'File::Basename'            => 0,
        'File::Spec'                => 0,
        'File::Temp'                => 0,
        'Getopt::Long'              => 0,
        'IPC::Cmd'                  => 0,
        'IPC::Run'                  => 0,
        'Math::Trig'                => 0,
        'Pod::Usage'                => 0,
        'PS::IPP::Config'           => '1.01',
        'PS::IPP::Metadata::Config' => 0,
        'Statistics::Descriptive'   => 0,
        'Storable'                  => 0,
        'Sys::Hostname'             => 0,
    },
    recommends          => {
        'Test::Distribution'    => '1.22',
    },
    script_files        => [qw(
        scripts/ipp_datapath.pl
        scripts/ipp_filename.pl
        scripts/mdc2list.pl
        scripts/register_imfile.pl
        scripts/register_exp.pl
        scripts/detrend_correct_imfile.pl
        scripts/detrend_process_imfile.pl
        scripts/detrend_process_exp.pl
        scripts/detrend_stack.pl
        scripts/detrend_norm_calc.pl
        scripts/detrend_norm_apply.pl
        scripts/detrend_norm_exp.pl
        scripts/detrend_resid_imfile.pl
        scripts/detrend_resid_exp.pl
        scripts/detrend_reject_exp.pl
        scripts/flatcorr_proc.pl
        scripts/chip_imfile.pl
        scripts/camera_exp.pl
        scripts/fake_imfile.pl
        scripts/warp_overlap.pl
        scripts/warp_skycell.pl
        scripts/diff_skycell.pl
        scripts/stack_skycell.pl
        scripts/magic_tree.pl
        scripts/magic_process.pl
        scripts/magic_mask.pl
        scripts/magic_destreak.pl
        scripts/ippdb.pl
        scripts/ipp_cleanup.pl
        scripts/ipp_inject_fileset.pl
        scripts/ipp_inject_expname.pl
        scripts/ipp_serial_inject.pl
        scripts/ipp_serial_inject_split.pl
        scripts/ipp_serial_inject_mosaic.pl
        scripts/ipp_serial_register.pl
        scripts/ipp_serial_detrend.pl
        scripts/ipp_serial_chip.pl
        scripts/ipp_serial_camera.pl
        scripts/ipp_serial_warp.pl
        scripts/ipp_serial_diff.pl
        scripts/ipp_serial_stack.pl
        scripts/ipp_serial_mops.pl
        scripts/ipp_mops_translate.pl
        scripts/ipp_simulation_data.pl
        scripts/isp_trans.pl
        scripts/ds9_cmf_regions.pl
        scripts/ipp_detrend_combine.pl
        scripts/summit_copy.pl
        scripts/ipp_image_path.pl
    )],
    dist_abstract => 'Scripts for running the Pan-STARRS IPP',
    dist_author => 'Paul Price <price@ifa.hawaii.edu>',
)->create_build_script;
