/*
 * pxwarp.h
 *
 * Copyright (C) 2007-2008  Joshua Hoblitt
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * program; see the file COPYING. If not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef PXWARP_H
#define PXWARP_H 1

#include <pslib.h>

#include "pxtools.h"

bool pxwarpRunSetState(pxConfig *config, psS64 warp_id, const char *state);
bool pxwarpRunSetStateByQuery(pxConfig *config, psMetadata *where, const char *state);
bool pxwarpRunSetLabel(pxConfig *config, psS64 warp_id, const char *label);
bool pxwarpRunSetLabelByQuery(pxConfig *config, psMetadata *where, const char *label);

bool pxwarpQueueByFakeID(pxConfig *config,
                    psS64 fake_id,
                    char *workdir,
                    char *label,
                    char *dvodb,
                    char *tess_id,
                    char *end_stage);

#endif // PXWARP_H
