/** @file pmResiduals.h
 *
 * Functions to manipulate the residual tables (data - model).
 *
 * @author EAM, IfA
 * @version $Revision: 1.3 $ $Name: ipp-magic-v0-0 $
 * @date $Date: 2007/11/10 01:09:20 $
 * Copyright 2004 IfA, University of Hawaii
 */

# ifndef PM_RESIDUALS_H
# define PM_RESIDUALS_H
/// @addtogroup Objects Object Detection / Analysis Functions
/// @{

/** residual tables for sources 
 */
typedef struct {
    psImage *Ro;
    psImage *Rx;
    psImage *Ry;
    psImage *weight;
    psImage *mask;
    int xBin;
    int yBin;
    int xCenter;
    int yCenter;
} pmResiduals;

pmResiduals *pmResidualsAlloc (int xSize, int ySize, int xBin, int yBin);
bool psMemCheckResiduals(psPtr ptr);

/// @}
# endif
