#ifndef PM_SKY_CELL_H
#define PM_SKY_CELL_H

/// Structure representing a sky cell
typedef struct
{
    psImage *image;                     // Image; type F32
    psImage *mask;                      // Mask image; type MASK_TYPE
    psImage *weight;                    // Weight map; type F32
    psPlaneTransform *toTPA;            // Transformation from pixels to tangent plane
    psPlaneTransform *fromTPA;          // Transformation from tangent plane to pixels
    psProjection *toSky;                // Projection to the sky
}
pmSkyCell;



#endif
